Attribute VB_Name = "Module1"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"389728900212"
Attribute VB_Ext_KEY = "RVB_ModelStereotype" ,"Module"
Option Explicit

'##ModelId=38972891008F
Global theCountries As Countries
'##ModelId=3897289002BC
Public Type Token
    '##ModelId=3897289002EE
    TokenType As Integer
    '##ModelId=38972890032A
    TokenString As String
End Type
'##ModelId=389728910244
Const K_COUNTRY = 1
'##ModelId=389728910276
Const K_HOLIDAY = 2
'##ModelId=3897289102E6
Global oProjectApp As MSProject.Application
'##ModelId=389728910354
Global oProjectPlan As MSProject.Project
'##ModelId=3897289103C2
Global oProjectCalendar As MSProject.Calendar




'##ModelId=389728920014
Public Sub AddAHoliday(aCountry As String, aHoliday As String, aDate As Date)
Dim aNewCountry As COUNTRY
Dim aNewHoliday As HOLIDAY
Dim aHolidayDate As HolidayDate
Set aNewCountry = theCountries.Add(aCountry, aCountry)
Set aNewHoliday = aNewCountry.Holidays.Add(aHoliday, aHoliday)
Set aHolidayDate = aNewHoliday.HolidayDates.Add(aDate)
Set aHolidayDate = Nothing
Set aNewHoliday = Nothing
Set aNewCountry = Nothing
End Sub


'##ModelId=389728920082
Public Sub ReadFile()
' The path is hardcoded in this example to C:\Temp\Outlook.txt
Open "C:\Temp\Outlook.txt" For Input Access Read As 1
Dim aLine As String
Dim result As Token
Dim oCurrentCountry As COUNTRY
Dim oCurrentHoliday As HOLIDAY
Dim oCurrentDate As HolidayDate
Dim dJulian As Date
Dim dOther As Date
Dim sHoliday As String
Dim theHoliday As Variant 'The only reason for doing this is for the holidays the have a julian and a religious date

While Not EOF(1)
    Line Input #1, aLine
    result = ParseLine(aLine)
    Select Case result.TokenType
    Case K_COUNTRY
        Set oCurrentCountry = theCountries.Add(result.TokenString, result.TokenString)
        'Debug.Print "Found Country ", result.TokenString
    Case K_HOLIDAY
        'Debug.Print "Found a Holiday ", result.TokenString
        theHoliday = Split(result.TokenString, ",")
        'Debug.Print UBound(theHoliday)
        sHoliday = theHoliday(0)
        Set oCurrentHoliday = oCurrentCountry.Holidays.Add(sHoliday, sHoliday)
        dJulian = theHoliday(1)
        If UBound(theHoliday) = 2 Then
            dOther = theHoliday(2)
            Set oCurrentDate = oCurrentHoliday.HolidayDates.Add(dJulian, dOther)
        Else
            Set oCurrentDate = oCurrentHoliday.HolidayDates.Add(dJulian)
        End If
    End Select
Wend

End Sub

'##ModelId=3897289200B4
Function ParseLine(aLine) As Token
Dim iLeftSquare As Integer
Dim iRightSquare As Integer
Dim tmpToken As Token

' Check to see if it's a country
iLeftSquare = InStr(1, aLine, "[")
iRightSquare = InStr(1, aLine, "]")
If (iLeftSquare > 0) And (iRightSquare > 0) Then
    tmpToken.TokenType = K_COUNTRY
    tmpToken.TokenString = Mid(aLine, iLeftSquare + 1, iRightSquare - 2)
    'Debug.Print tmpToken.TokenString
Else
    tmpToken.TokenType = K_HOLIDAY
    tmpToken.TokenString = aLine
End If
ParseLine = tmpToken
End Function

'##ModelId=3897289200F0
Public Sub Initialize()
'this is invoked from the form of the test program
Set oProjectApp = GetObject(, "MSProject.Application")
Set oProjectPlan = oProjectApp.ActiveProject

End Sub

'##ModelId=3897289200F1
Public Sub AddDatesToCalendar(theHoliday As HOLIDAY)
Dim aPeriod As MSProject.Period
Set oProjectCalendar = oProjectPlan.Calendar

Dim aHolidayDate As HolidayDate
For Each aHolidayDate In theHoliday.HolidayDates
    Debug.Print theHoliday.HolidayName, aHolidayDate.JUlianDate
    'Set aPeriod = oProjectCalendar.BaseCalendar.Period(aHolidayDate.JUlianDate)
    oProjectCalendar.Period(aHolidayDate.JUlianDate).Working = False
Next aHolidayDate
End Sub
