VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Countries"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Country"
Attribute VB_Ext_KEY = "Member0" ,"Country"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"38972891008C"
'local variable to hold collection
'##ModelId=3897289401AE
Private mCol As Collection
Attribute mCol.VB_VarDescription = "local variable to hold collection"

'##ModelId=3897289401EA
Public Function Exists(sKey As String) As Boolean
' Returns TRUE if the key is already contain in the collection
Exists = True
On Error GoTo DoesNotExist
Dim tstCountry As COUNTRY
Set tstCountry = mCol.Item(sKey)
Set tstCountry = Nothing
Exit Function
DoesNotExist:
    Exists = False
End Function

'##ModelId=38972894021C
Public Function Add(CountryName As String, Optional sKey As String) As COUNTRY
    'create a new object
    Dim objNewMember As COUNTRY
    
    If Not Exists(sKey) Then
        Set objNewMember = New COUNTRY
        'set the properties passed into the method
        objNewMember.CountryName = CountryName
        If Len(sKey) = 0 Then
            mCol.Add objNewMember
        Else
            mCol.Add objNewMember, sKey
        End If

    Else
    Set objNewMember = mCol.Item(sKey)
    End If
    
    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

'##ModelId=389728940258
Public Property Get Item(vntIndexKey As Variant) As COUNTRY
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



'##ModelId=38972894028B
Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


'##ModelId=3897289402C6
Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


'##ModelId=3897289402F8
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


'##ModelId=3897289402F9
Private Sub Class_Initialize()
    'creates the collection when this class is created
    'Debug.Print "created the countries"
    Set mCol = New Collection
End Sub


'##ModelId=389728940366
Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    'Debug.Print "destroyed the countries"
    Set mCol = Nothing
End Sub

